<?php
/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'AddressToFormatS42FieldsType' => '\\StructType\\AddressToFormatS42FieldsType',
            'FormatAddressesRequestType' => '\\StructType\\FormatAddressesRequestType',
            'AddressToFormatList' => '\\StructType\\AddressToFormatList',
            'FormatAddressesResponseType' => '\\StructType\\FormatAddressesResponseType',
            'FormattedAddressResultList' => '\\StructType\\FormattedAddressResultList',
            'FormatUPUAddressesRequestType' => '\\StructType\\FormatUPUAddressesRequestType',
            'FormatUPUAddressesResponseType' => '\\StructType\\FormatUPUAddressesResponseType',
            'ValidateAddressesRequestType' => '\\StructType\\ValidateAddressesRequestType',
            'AddressToValidateList' => '\\StructType\\AddressToValidateList',
            'ValidateAddressesResponseType' => '\\StructType\\ValidateAddressesResponseType',
            'ValidatedAddressResultList' => '\\StructType\\ValidatedAddressResultList',
            'ProvideFeedbackRequestType' => '\\StructType\\ProvideFeedbackRequestType',
            'ProvideFeedbackResponseType' => '\\StructType\\ProvideFeedbackResponseType',
            'AddressToValidateType' => '\\StructType\\AddressToValidateType',
            'ValidatedAddressResultType' => '\\StructType\\ValidatedAddressResultType',
            'ValidatedAddressList' => '\\StructType\\ValidatedAddressList',
            'AddressToFormatType' => '\\StructType\\AddressToFormatType',
            'FormattedAddressResultType' => '\\StructType\\FormattedAddressResultType',
            'MaileeAndAddresseeType' => '\\StructType\\MaileeAndAddresseeType',
            'StructuredMaileeAndAddresseeType' => '\\StructType\\StructuredMaileeAndAddresseeType',
            'PostalAddressType' => '\\StructType\\PostalAddressType',
            'StructuredPostalAddressType' => '\\StructType\\StructuredPostalAddressType',
            'ValidatedAddressType' => '\\StructType\\ValidatedAddressType',
            'ServicePointSuffixListType' => '\\StructType\\ServicePointSuffixListType',
            'ServicePointBoxListType' => '\\StructType\\ServicePointBoxListType',
            'ServicePointBoxResultType' => '\\StructType\\ServicePointBoxResultType',
            'ServicePointDetailType' => '\\StructType\\ServicePointDetailType',
            'GeographicalLocationInfoType' => '\\StructType\\GeographicalLocationInfoType',
            'GeographicalLocationType' => '\\StructType\\GeographicalLocationType',
            'Latitude' => '\\StructType\\Latitude',
            'Longitude' => '\\StructType\\Longitude',
            'DimensionType' => '\\StructType\\DimensionType',
            'LabelType' => '\\StructType\\LabelType',
            'ErrorType' => '\\StructType\\ErrorType',
            'GeneralErrorType' => '\\StructType\\GeneralErrorType',
            'ValidateAddressOptionsType' => '\\StructType\\ValidateAddressOptionsType',
            'StructuredMailRecipientDispatchingInformationType' => '\\StructType\\StructuredMailRecipientDispatchingInformationType',
            'WingType' => '\\StructType\\WingType',
            'StairwellType' => '\\StructType\\StairwellType',
            'FloorType' => '\\StructType\\FloorType',
            'DoorType' => '\\StructType\\DoorType',
            'StructuredMaileeOrganizationIdentificationComplexType' => '\\StructType\\StructuredMaileeOrganizationIdentificationComplexType',
            'StructuredMaileeIndividualIdentificationComplexType' => '\\StructType\\StructuredMaileeIndividualIdentificationComplexType',
            'StructuredAddresseeIndividualIdentificationComplexType' => '\\StructType\\StructuredAddresseeIndividualIdentificationComplexType',
            'StructuredOtherDeliveryInformationComplexType' => '\\StructType\\StructuredOtherDeliveryInformationComplexType',
            'StructuredDeliveryPointLocationComplexType' => '\\StructType\\StructuredDeliveryPointLocationComplexType',
            'StructuredPostalCodeMunicipalityComplexType' => '\\StructType\\StructuredPostalCodeMunicipalityComplexType',
            'AddresseeIndividualIdentificationComplexType' => '\\StructType\\AddresseeIndividualIdentificationComplexType',
            'MaileeIndividualIdentificationComplexType' => '\\StructType\\MaileeIndividualIdentificationComplexType',
            'MaileeOrganizationIdentificationComplexType' => '\\StructType\\MaileeOrganizationIdentificationComplexType',
            'MailRecipientDispatchingInformationComplexType' => '\\StructType\\MailRecipientDispatchingInformationComplexType',
            'OtherDeliveryInformationComplexType' => '\\StructType\\OtherDeliveryInformationComplexType',
            'DeliveryPointLocationComplexType' => '\\StructType\\DeliveryPointLocationComplexType',
            'PostalCodeMunicipalityComplexType' => '\\StructType\\PostalCodeMunicipalityComplexType',
            'AddressBlockLinesType' => '\\StructType\\AddressBlockLinesType',
            'LocalizedStringType' => '\\StructType\\LocalizedStringType',
            'CallerIdentificationType' => '\\StructType\\CallerIdentificationType',
        );
    }
}
