<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for DeliveryPointLocationComplexType StructType
 * @subpackage Structs
 */
class DeliveryPointLocationComplexType extends AbstractStructBase
{
    /**
     * The StructuredDeliveryPointLocation
     * Meta informations extracted from the WSDL
     * - ref: msg:StructuredDeliveryPointLocation
     * @var \StructType\StructuredDeliveryPointLocationComplexType
     */
    public $StructuredDeliveryPointLocation;
    /**
     * The UnstructuredDeliveryPointLocation
     * @var string
     */
    public $UnstructuredDeliveryPointLocation;
    /**
     * Constructor method for DeliveryPointLocationComplexType
     * @uses DeliveryPointLocationComplexType::setStructuredDeliveryPointLocation()
     * @uses DeliveryPointLocationComplexType::setUnstructuredDeliveryPointLocation()
     * @param \StructType\StructuredDeliveryPointLocationComplexType $structuredDeliveryPointLocation
     * @param string $unstructuredDeliveryPointLocation
     */
    public function __construct(\StructType\StructuredDeliveryPointLocationComplexType $structuredDeliveryPointLocation = null, $unstructuredDeliveryPointLocation = null)
    {
        $this
            ->setStructuredDeliveryPointLocation($structuredDeliveryPointLocation)
            ->setUnstructuredDeliveryPointLocation($unstructuredDeliveryPointLocation);
    }
    /**
     * Get StructuredDeliveryPointLocation value
     * @return \StructType\StructuredDeliveryPointLocationComplexType|null
     */
    public function getStructuredDeliveryPointLocation()
    {
        return $this->StructuredDeliveryPointLocation;
    }
    /**
     * Set StructuredDeliveryPointLocation value
     * @param \StructType\StructuredDeliveryPointLocationComplexType $structuredDeliveryPointLocation
     * @return \StructType\DeliveryPointLocationComplexType
     */
    public function setStructuredDeliveryPointLocation(\StructType\StructuredDeliveryPointLocationComplexType $structuredDeliveryPointLocation = null)
    {
        $this->StructuredDeliveryPointLocation = $structuredDeliveryPointLocation;
        return $this;
    }
    /**
     * Get UnstructuredDeliveryPointLocation value
     * @return string|null
     */
    public function getUnstructuredDeliveryPointLocation()
    {
        return $this->UnstructuredDeliveryPointLocation;
    }
    /**
     * Set UnstructuredDeliveryPointLocation value
     * @param string $unstructuredDeliveryPointLocation
     * @return \StructType\DeliveryPointLocationComplexType
     */
    public function setUnstructuredDeliveryPointLocation($unstructuredDeliveryPointLocation = null)
    {
        // validation for constraint: string
        if (!is_null($unstructuredDeliveryPointLocation) && !is_string($unstructuredDeliveryPointLocation)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($unstructuredDeliveryPointLocation)), __LINE__);
        }
        $this->UnstructuredDeliveryPointLocation = $unstructuredDeliveryPointLocation;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\DeliveryPointLocationComplexType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
