<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for FormattedAddressResultList StructType
 * @subpackage Structs
 */
class FormattedAddressResultList extends AbstractStructBase
{
    /**
     * The FormattedAddressResult
     * Meta informations extracted from the WSDL
     * - maxOccurs: 200
     * @var \StructType\FormattedAddressResultType[]
     */
    public $FormattedAddressResult;
    /**
     * Constructor method for FormattedAddressResultList
     * @uses FormattedAddressResultList::setFormattedAddressResult()
     * @param \StructType\FormattedAddressResultType[] $formattedAddressResult
     */
    public function __construct(array $formattedAddressResult = array())
    {
        $this
            ->setFormattedAddressResult($formattedAddressResult);
    }
    /**
     * Get FormattedAddressResult value
     * @return \StructType\FormattedAddressResultType[]|null
     */
    public function getFormattedAddressResult()
    {
        return $this->FormattedAddressResult;
    }
    /**
     * Set FormattedAddressResult value
     * @throws \InvalidArgumentException
     * @param \StructType\FormattedAddressResultType[] $formattedAddressResult
     * @return \StructType\FormattedAddressResultList
     */
    public function setFormattedAddressResult(array $formattedAddressResult = array())
    {
        foreach ($formattedAddressResult as $formattedAddressResultListFormattedAddressResultItem) {
            // validation for constraint: itemType
            if (!$formattedAddressResultListFormattedAddressResultItem instanceof \StructType\FormattedAddressResultType) {
                throw new \InvalidArgumentException(sprintf('The FormattedAddressResult property can only contain items of \StructType\FormattedAddressResultType, "%s" given', is_object($formattedAddressResultListFormattedAddressResultItem) ? get_class($formattedAddressResultListFormattedAddressResultItem) : gettype($formattedAddressResultListFormattedAddressResultItem)), __LINE__);
            }
        }
        $this->FormattedAddressResult = $formattedAddressResult;
        return $this;
    }
    /**
     * Add item to FormattedAddressResult value
     * @throws \InvalidArgumentException
     * @param \StructType\FormattedAddressResultType $item
     * @return \StructType\FormattedAddressResultList
     */
    public function addToFormattedAddressResult(\StructType\FormattedAddressResultType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\FormattedAddressResultType) {
            throw new \InvalidArgumentException(sprintf('The FormattedAddressResult property can only contain items of \StructType\FormattedAddressResultType, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->FormattedAddressResult[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\FormattedAddressResultList
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
