<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for FormattedAddressResultType StructType
 * @subpackage Structs
 */
class FormattedAddressResultType extends AbstractStructBase
{
    /**
     * The id
     * Meta informations extracted from the WSDL
     * - use: required
     * @var string
     */
    public $id;
    /**
     * The Label
     * Meta informations extracted from the WSDL
     * - ref: msg:Label
     * @var \StructType\LabelType
     */
    public $Label;
    /**
     * The Error
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\GeneralErrorType
     */
    public $Error;
    /**
     * Constructor method for FormattedAddressResultType
     * @uses FormattedAddressResultType::setId()
     * @uses FormattedAddressResultType::setLabel()
     * @uses FormattedAddressResultType::setError()
     * @param string $id
     * @param \StructType\LabelType $label
     * @param \StructType\GeneralErrorType $error
     */
    public function __construct($id = null, \StructType\LabelType $label = null, \StructType\GeneralErrorType $error = null)
    {
        $this
            ->setId($id)
            ->setLabel($label)
            ->setError($error);
    }
    /**
     * Get id value
     * @return string
     */
    public function getId()
    {
        return $this->id;
    }
    /**
     * Set id value
     * @param string $id
     * @return \StructType\FormattedAddressResultType
     */
    public function setId($id = null)
    {
        // validation for constraint: string
        if (!is_null($id) && !is_string($id)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($id)), __LINE__);
        }
        $this->id = $id;
        return $this;
    }
    /**
     * Get Label value
     * @return \StructType\LabelType|null
     */
    public function getLabel()
    {
        return $this->Label;
    }
    /**
     * Set Label value
     * @param \StructType\LabelType $label
     * @return \StructType\FormattedAddressResultType
     */
    public function setLabel(\StructType\LabelType $label = null)
    {
        $this->Label = $label;
        return $this;
    }
    /**
     * Get Error value
     * @return \StructType\GeneralErrorType|null
     */
    public function getError()
    {
        return $this->Error;
    }
    /**
     * Set Error value
     * @param \StructType\GeneralErrorType $error
     * @return \StructType\FormattedAddressResultType
     */
    public function setError(\StructType\GeneralErrorType $error = null)
    {
        $this->Error = $error;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\FormattedAddressResultType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
