<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ServicePointBoxListType StructType
 * @subpackage Structs
 */
class ServicePointBoxListType extends AbstractStructBase
{
    /**
     * The ServicePointBoxResult
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * @var \StructType\ServicePointBoxResultType[]
     */
    public $ServicePointBoxResult;
    /**
     * Constructor method for ServicePointBoxListType
     * @uses ServicePointBoxListType::setServicePointBoxResult()
     * @param \StructType\ServicePointBoxResultType[] $servicePointBoxResult
     */
    public function __construct(array $servicePointBoxResult = array())
    {
        $this
            ->setServicePointBoxResult($servicePointBoxResult);
    }
    /**
     * Get ServicePointBoxResult value
     * @return \StructType\ServicePointBoxResultType[]|null
     */
    public function getServicePointBoxResult()
    {
        return $this->ServicePointBoxResult;
    }
    /**
     * Set ServicePointBoxResult value
     * @throws \InvalidArgumentException
     * @param \StructType\ServicePointBoxResultType[] $servicePointBoxResult
     * @return \StructType\ServicePointBoxListType
     */
    public function setServicePointBoxResult(array $servicePointBoxResult = array())
    {
        foreach ($servicePointBoxResult as $servicePointBoxListTypeServicePointBoxResultItem) {
            // validation for constraint: itemType
            if (!$servicePointBoxListTypeServicePointBoxResultItem instanceof \StructType\ServicePointBoxResultType) {
                throw new \InvalidArgumentException(sprintf('The ServicePointBoxResult property can only contain items of \StructType\ServicePointBoxResultType, "%s" given', is_object($servicePointBoxListTypeServicePointBoxResultItem) ? get_class($servicePointBoxListTypeServicePointBoxResultItem) : gettype($servicePointBoxListTypeServicePointBoxResultItem)), __LINE__);
            }
        }
        $this->ServicePointBoxResult = $servicePointBoxResult;
        return $this;
    }
    /**
     * Add item to ServicePointBoxResult value
     * @throws \InvalidArgumentException
     * @param \StructType\ServicePointBoxResultType $item
     * @return \StructType\ServicePointBoxListType
     */
    public function addToServicePointBoxResult(\StructType\ServicePointBoxResultType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ServicePointBoxResultType) {
            throw new \InvalidArgumentException(sprintf('The ServicePointBoxResult property can only contain items of \StructType\ServicePointBoxResultType, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->ServicePointBoxResult[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ServicePointBoxListType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
