<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ServicePointSuffixListType StructType
 * @subpackage Structs
 */
class ServicePointSuffixListType extends AbstractStructBase
{
    /**
     * The ServicePointSuffixResult
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * @var \StructType\ServicePointBoxResultType[]
     */
    public $ServicePointSuffixResult;
    /**
     * Constructor method for ServicePointSuffixListType
     * @uses ServicePointSuffixListType::setServicePointSuffixResult()
     * @param \StructType\ServicePointBoxResultType[] $servicePointSuffixResult
     */
    public function __construct(array $servicePointSuffixResult = array())
    {
        $this
            ->setServicePointSuffixResult($servicePointSuffixResult);
    }
    /**
     * Get ServicePointSuffixResult value
     * @return \StructType\ServicePointBoxResultType[]|null
     */
    public function getServicePointSuffixResult()
    {
        return $this->ServicePointSuffixResult;
    }
    /**
     * Set ServicePointSuffixResult value
     * @throws \InvalidArgumentException
     * @param \StructType\ServicePointBoxResultType[] $servicePointSuffixResult
     * @return \StructType\ServicePointSuffixListType
     */
    public function setServicePointSuffixResult(array $servicePointSuffixResult = array())
    {
        foreach ($servicePointSuffixResult as $servicePointSuffixListTypeServicePointSuffixResultItem) {
            // validation for constraint: itemType
            if (!$servicePointSuffixListTypeServicePointSuffixResultItem instanceof \StructType\ServicePointBoxResultType) {
                throw new \InvalidArgumentException(sprintf('The ServicePointSuffixResult property can only contain items of \StructType\ServicePointBoxResultType, "%s" given', is_object($servicePointSuffixListTypeServicePointSuffixResultItem) ? get_class($servicePointSuffixListTypeServicePointSuffixResultItem) : gettype($servicePointSuffixListTypeServicePointSuffixResultItem)), __LINE__);
            }
        }
        $this->ServicePointSuffixResult = $servicePointSuffixResult;
        return $this;
    }
    /**
     * Add item to ServicePointSuffixResult value
     * @throws \InvalidArgumentException
     * @param \StructType\ServicePointBoxResultType $item
     * @return \StructType\ServicePointSuffixListType
     */
    public function addToServicePointSuffixResult(\StructType\ServicePointBoxResultType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ServicePointBoxResultType) {
            throw new \InvalidArgumentException(sprintf('The ServicePointSuffixResult property can only contain items of \StructType\ServicePointBoxResultType, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->ServicePointSuffixResult[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ServicePointSuffixListType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
