<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for StructuredAddresseeIndividualIdentificationComplexType
 * StructType
 * @subpackage Structs
 */
class StructuredAddresseeIndividualIdentificationComplexType extends AbstractStructBase
{
    /**
     * The AddresseeFormOfAddress
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $AddresseeFormOfAddress;
    /**
     * The AddresseeGivenName
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $AddresseeGivenName;
    /**
     * The AddresseeSurname
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $AddresseeSurname;
    /**
     * The AddresseeSupplementaryDispatchInfo
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $AddresseeSupplementaryDispatchInfo;
    /**
     * Constructor method for StructuredAddresseeIndividualIdentificationComplexType
     * @uses StructuredAddresseeIndividualIdentificationComplexType::setAddresseeFormOfAddress()
     * @uses StructuredAddresseeIndividualIdentificationComplexType::setAddresseeGivenName()
     * @uses StructuredAddresseeIndividualIdentificationComplexType::setAddresseeSurname()
     * @uses StructuredAddresseeIndividualIdentificationComplexType::setAddresseeSupplementaryDispatchInfo()
     * @param string $addresseeFormOfAddress
     * @param string $addresseeGivenName
     * @param string $addresseeSurname
     * @param string $addresseeSupplementaryDispatchInfo
     */
    public function __construct($addresseeFormOfAddress = null, $addresseeGivenName = null, $addresseeSurname = null, $addresseeSupplementaryDispatchInfo = null)
    {
        $this
            ->setAddresseeFormOfAddress($addresseeFormOfAddress)
            ->setAddresseeGivenName($addresseeGivenName)
            ->setAddresseeSurname($addresseeSurname)
            ->setAddresseeSupplementaryDispatchInfo($addresseeSupplementaryDispatchInfo);
    }
    /**
     * Get AddresseeFormOfAddress value
     * @return string|null
     */
    public function getAddresseeFormOfAddress()
    {
        return $this->AddresseeFormOfAddress;
    }
    /**
     * Set AddresseeFormOfAddress value
     * @param string $addresseeFormOfAddress
     * @return \StructType\StructuredAddresseeIndividualIdentificationComplexType
     */
    public function setAddresseeFormOfAddress($addresseeFormOfAddress = null)
    {
        // validation for constraint: string
        if (!is_null($addresseeFormOfAddress) && !is_string($addresseeFormOfAddress)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($addresseeFormOfAddress)), __LINE__);
        }
        $this->AddresseeFormOfAddress = $addresseeFormOfAddress;
        return $this;
    }
    /**
     * Get AddresseeGivenName value
     * @return string|null
     */
    public function getAddresseeGivenName()
    {
        return $this->AddresseeGivenName;
    }
    /**
     * Set AddresseeGivenName value
     * @param string $addresseeGivenName
     * @return \StructType\StructuredAddresseeIndividualIdentificationComplexType
     */
    public function setAddresseeGivenName($addresseeGivenName = null)
    {
        // validation for constraint: string
        if (!is_null($addresseeGivenName) && !is_string($addresseeGivenName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($addresseeGivenName)), __LINE__);
        }
        $this->AddresseeGivenName = $addresseeGivenName;
        return $this;
    }
    /**
     * Get AddresseeSurname value
     * @return string|null
     */
    public function getAddresseeSurname()
    {
        return $this->AddresseeSurname;
    }
    /**
     * Set AddresseeSurname value
     * @param string $addresseeSurname
     * @return \StructType\StructuredAddresseeIndividualIdentificationComplexType
     */
    public function setAddresseeSurname($addresseeSurname = null)
    {
        // validation for constraint: string
        if (!is_null($addresseeSurname) && !is_string($addresseeSurname)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($addresseeSurname)), __LINE__);
        }
        $this->AddresseeSurname = $addresseeSurname;
        return $this;
    }
    /**
     * Get AddresseeSupplementaryDispatchInfo value
     * @return string|null
     */
    public function getAddresseeSupplementaryDispatchInfo()
    {
        return $this->AddresseeSupplementaryDispatchInfo;
    }
    /**
     * Set AddresseeSupplementaryDispatchInfo value
     * @param string $addresseeSupplementaryDispatchInfo
     * @return \StructType\StructuredAddresseeIndividualIdentificationComplexType
     */
    public function setAddresseeSupplementaryDispatchInfo($addresseeSupplementaryDispatchInfo = null)
    {
        // validation for constraint: string
        if (!is_null($addresseeSupplementaryDispatchInfo) && !is_string($addresseeSupplementaryDispatchInfo)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($addresseeSupplementaryDispatchInfo)), __LINE__);
        }
        $this->AddresseeSupplementaryDispatchInfo = $addresseeSupplementaryDispatchInfo;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\StructuredAddresseeIndividualIdentificationComplexType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
