<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for StructuredMaileeIndividualIdentificationComplexType
 * StructType
 * @subpackage Structs
 */
class StructuredMaileeIndividualIdentificationComplexType extends AbstractStructBase
{
    /**
     * The MaileeRole
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $MaileeRole;
    /**
     * The MaileeFormOfAddress
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $MaileeFormOfAddress;
    /**
     * The MaileeGivenName
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $MaileeGivenName;
    /**
     * The MaileeSurname
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $MaileeSurname;
    /**
     * Constructor method for StructuredMaileeIndividualIdentificationComplexType
     * @uses StructuredMaileeIndividualIdentificationComplexType::setMaileeRole()
     * @uses StructuredMaileeIndividualIdentificationComplexType::setMaileeFormOfAddress()
     * @uses StructuredMaileeIndividualIdentificationComplexType::setMaileeGivenName()
     * @uses StructuredMaileeIndividualIdentificationComplexType::setMaileeSurname()
     * @param string $maileeRole
     * @param string $maileeFormOfAddress
     * @param string $maileeGivenName
     * @param string $maileeSurname
     */
    public function __construct($maileeRole = null, $maileeFormOfAddress = null, $maileeGivenName = null, $maileeSurname = null)
    {
        $this
            ->setMaileeRole($maileeRole)
            ->setMaileeFormOfAddress($maileeFormOfAddress)
            ->setMaileeGivenName($maileeGivenName)
            ->setMaileeSurname($maileeSurname);
    }
    /**
     * Get MaileeRole value
     * @return string|null
     */
    public function getMaileeRole()
    {
        return $this->MaileeRole;
    }
    /**
     * Set MaileeRole value
     * @param string $maileeRole
     * @return \StructType\StructuredMaileeIndividualIdentificationComplexType
     */
    public function setMaileeRole($maileeRole = null)
    {
        // validation for constraint: string
        if (!is_null($maileeRole) && !is_string($maileeRole)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($maileeRole)), __LINE__);
        }
        $this->MaileeRole = $maileeRole;
        return $this;
    }
    /**
     * Get MaileeFormOfAddress value
     * @return string|null
     */
    public function getMaileeFormOfAddress()
    {
        return $this->MaileeFormOfAddress;
    }
    /**
     * Set MaileeFormOfAddress value
     * @param string $maileeFormOfAddress
     * @return \StructType\StructuredMaileeIndividualIdentificationComplexType
     */
    public function setMaileeFormOfAddress($maileeFormOfAddress = null)
    {
        // validation for constraint: string
        if (!is_null($maileeFormOfAddress) && !is_string($maileeFormOfAddress)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($maileeFormOfAddress)), __LINE__);
        }
        $this->MaileeFormOfAddress = $maileeFormOfAddress;
        return $this;
    }
    /**
     * Get MaileeGivenName value
     * @return string|null
     */
    public function getMaileeGivenName()
    {
        return $this->MaileeGivenName;
    }
    /**
     * Set MaileeGivenName value
     * @param string $maileeGivenName
     * @return \StructType\StructuredMaileeIndividualIdentificationComplexType
     */
    public function setMaileeGivenName($maileeGivenName = null)
    {
        // validation for constraint: string
        if (!is_null($maileeGivenName) && !is_string($maileeGivenName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($maileeGivenName)), __LINE__);
        }
        $this->MaileeGivenName = $maileeGivenName;
        return $this;
    }
    /**
     * Get MaileeSurname value
     * @return string|null
     */
    public function getMaileeSurname()
    {
        return $this->MaileeSurname;
    }
    /**
     * Set MaileeSurname value
     * @param string $maileeSurname
     * @return \StructType\StructuredMaileeIndividualIdentificationComplexType
     */
    public function setMaileeSurname($maileeSurname = null)
    {
        // validation for constraint: string
        if (!is_null($maileeSurname) && !is_string($maileeSurname)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($maileeSurname)), __LINE__);
        }
        $this->MaileeSurname = $maileeSurname;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\StructuredMaileeIndividualIdentificationComplexType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
