<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for StructuredMaileeOrganizationIdentificationComplexType
 * StructType
 * @subpackage Structs
 */
class StructuredMaileeOrganizationIdentificationComplexType extends AbstractStructBase
{
    /**
     * The MaileeOrganizationFunction
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $MaileeOrganizationFunction;
    /**
     * The MaileeOrganizationOrganizationalUnit
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $MaileeOrganizationOrganizationalUnit;
    /**
     * The MaileeOrganizationOrganizationalName
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $MaileeOrganizationOrganizationalName;
    /**
     * The MaileeOrganizationLegalStatus
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $MaileeOrganizationLegalStatus;
    /**
     * Constructor method for StructuredMaileeOrganizationIdentificationComplexType
     * @uses StructuredMaileeOrganizationIdentificationComplexType::setMaileeOrganizationFunction()
     * @uses StructuredMaileeOrganizationIdentificationComplexType::setMaileeOrganizationOrganizationalUnit()
     * @uses StructuredMaileeOrganizationIdentificationComplexType::setMaileeOrganizationOrganizationalName()
     * @uses StructuredMaileeOrganizationIdentificationComplexType::setMaileeOrganizationLegalStatus()
     * @param string $maileeOrganizationFunction
     * @param string $maileeOrganizationOrganizationalUnit
     * @param string $maileeOrganizationOrganizationalName
     * @param string $maileeOrganizationLegalStatus
     */
    public function __construct($maileeOrganizationFunction = null, $maileeOrganizationOrganizationalUnit = null, $maileeOrganizationOrganizationalName = null, $maileeOrganizationLegalStatus = null)
    {
        $this
            ->setMaileeOrganizationFunction($maileeOrganizationFunction)
            ->setMaileeOrganizationOrganizationalUnit($maileeOrganizationOrganizationalUnit)
            ->setMaileeOrganizationOrganizationalName($maileeOrganizationOrganizationalName)
            ->setMaileeOrganizationLegalStatus($maileeOrganizationLegalStatus);
    }
    /**
     * Get MaileeOrganizationFunction value
     * @return string|null
     */
    public function getMaileeOrganizationFunction()
    {
        return $this->MaileeOrganizationFunction;
    }
    /**
     * Set MaileeOrganizationFunction value
     * @param string $maileeOrganizationFunction
     * @return \StructType\StructuredMaileeOrganizationIdentificationComplexType
     */
    public function setMaileeOrganizationFunction($maileeOrganizationFunction = null)
    {
        // validation for constraint: string
        if (!is_null($maileeOrganizationFunction) && !is_string($maileeOrganizationFunction)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($maileeOrganizationFunction)), __LINE__);
        }
        $this->MaileeOrganizationFunction = $maileeOrganizationFunction;
        return $this;
    }
    /**
     * Get MaileeOrganizationOrganizationalUnit value
     * @return string|null
     */
    public function getMaileeOrganizationOrganizationalUnit()
    {
        return $this->MaileeOrganizationOrganizationalUnit;
    }
    /**
     * Set MaileeOrganizationOrganizationalUnit value
     * @param string $maileeOrganizationOrganizationalUnit
     * @return \StructType\StructuredMaileeOrganizationIdentificationComplexType
     */
    public function setMaileeOrganizationOrganizationalUnit($maileeOrganizationOrganizationalUnit = null)
    {
        // validation for constraint: string
        if (!is_null($maileeOrganizationOrganizationalUnit) && !is_string($maileeOrganizationOrganizationalUnit)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($maileeOrganizationOrganizationalUnit)), __LINE__);
        }
        $this->MaileeOrganizationOrganizationalUnit = $maileeOrganizationOrganizationalUnit;
        return $this;
    }
    /**
     * Get MaileeOrganizationOrganizationalName value
     * @return string|null
     */
    public function getMaileeOrganizationOrganizationalName()
    {
        return $this->MaileeOrganizationOrganizationalName;
    }
    /**
     * Set MaileeOrganizationOrganizationalName value
     * @param string $maileeOrganizationOrganizationalName
     * @return \StructType\StructuredMaileeOrganizationIdentificationComplexType
     */
    public function setMaileeOrganizationOrganizationalName($maileeOrganizationOrganizationalName = null)
    {
        // validation for constraint: string
        if (!is_null($maileeOrganizationOrganizationalName) && !is_string($maileeOrganizationOrganizationalName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($maileeOrganizationOrganizationalName)), __LINE__);
        }
        $this->MaileeOrganizationOrganizationalName = $maileeOrganizationOrganizationalName;
        return $this;
    }
    /**
     * Get MaileeOrganizationLegalStatus value
     * @return string|null
     */
    public function getMaileeOrganizationLegalStatus()
    {
        return $this->MaileeOrganizationLegalStatus;
    }
    /**
     * Set MaileeOrganizationLegalStatus value
     * @param string $maileeOrganizationLegalStatus
     * @return \StructType\StructuredMaileeOrganizationIdentificationComplexType
     */
    public function setMaileeOrganizationLegalStatus($maileeOrganizationLegalStatus = null)
    {
        // validation for constraint: string
        if (!is_null($maileeOrganizationLegalStatus) && !is_string($maileeOrganizationLegalStatus)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($maileeOrganizationLegalStatus)), __LINE__);
        }
        $this->MaileeOrganizationLegalStatus = $maileeOrganizationLegalStatus;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\StructuredMaileeOrganizationIdentificationComplexType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
