<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ValidateAddressOptionsType StructType
 * @subpackage Structs
 */
class ValidateAddressOptionsType extends AbstractStructBase
{
    /**
     * The IncludeFormatting
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - ref: msg:IncludeFormatting
     * @var bool
     */
    public $IncludeFormatting;
    /**
     * The IncludeSuggestions
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - ref: msg:IncludeSuggestions
     * @var bool
     */
    public $IncludeSuggestions;
    /**
     * The IncludeSubmittedAddress
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - ref: msg:IncludeSubmittedAddress
     * @var bool
     */
    public $IncludeSubmittedAddress;
    /**
     * The IncludeDefaultGeoLocation
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - ref: msg:IncludeDefaultGeoLocation
     * @var bool
     */
    public $IncludeDefaultGeoLocation;
    /**
     * The IncludeSuffixList
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - ref: msg:IncludeSuffixList
     * @var bool
     */
    public $IncludeSuffixList;
    /**
     * The IncludeNumberOfSuffixes
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - ref: msg:IncludeNumberOfSuffixes
     * @var bool
     */
    public $IncludeNumberOfSuffixes;
    /**
     * The IncludeListOfBoxes
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - ref: msg:IncludeListOfBoxes
     * @var bool
     */
    public $IncludeListOfBoxes;
    /**
     * The IncludeNumberOfBoxes
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - ref: msg:IncludeNumberOfBoxes
     * @var bool
     */
    public $IncludeNumberOfBoxes;
    /**
     * Constructor method for ValidateAddressOptionsType
     * @uses ValidateAddressOptionsType::setIncludeFormatting()
     * @uses ValidateAddressOptionsType::setIncludeSuggestions()
     * @uses ValidateAddressOptionsType::setIncludeSubmittedAddress()
     * @uses ValidateAddressOptionsType::setIncludeDefaultGeoLocation()
     * @uses ValidateAddressOptionsType::setIncludeSuffixList()
     * @uses ValidateAddressOptionsType::setIncludeNumberOfSuffixes()
     * @uses ValidateAddressOptionsType::setIncludeListOfBoxes()
     * @uses ValidateAddressOptionsType::setIncludeNumberOfBoxes()
     * @param bool $includeFormatting
     * @param bool $includeSuggestions
     * @param bool $includeSubmittedAddress
     * @param bool $includeDefaultGeoLocation
     * @param bool $includeSuffixList
     * @param bool $includeNumberOfSuffixes
     * @param bool $includeListOfBoxes
     * @param bool $includeNumberOfBoxes
     */
    public function __construct($includeFormatting = null, $includeSuggestions = null, $includeSubmittedAddress = null, $includeDefaultGeoLocation = null, $includeSuffixList = null, $includeNumberOfSuffixes = null, $includeListOfBoxes = null, $includeNumberOfBoxes = null)
    {
        $this
            ->setIncludeFormatting($includeFormatting)
            ->setIncludeSuggestions($includeSuggestions)
            ->setIncludeSubmittedAddress($includeSubmittedAddress)
            ->setIncludeDefaultGeoLocation($includeDefaultGeoLocation)
            ->setIncludeSuffixList($includeSuffixList)
            ->setIncludeNumberOfSuffixes($includeNumberOfSuffixes)
            ->setIncludeListOfBoxes($includeListOfBoxes)
            ->setIncludeNumberOfBoxes($includeNumberOfBoxes);
    }
    /**
     * Get IncludeFormatting value
     * @return bool|null
     */
    public function getIncludeFormatting()
    {
        return $this->IncludeFormatting;
    }
    /**
     * Set IncludeFormatting value
     * @param bool $includeFormatting
     * @return \StructType\ValidateAddressOptionsType
     */
    public function setIncludeFormatting($includeFormatting = null)
    {
        // validation for constraint: boolean
        if (!is_null($includeFormatting) && !is_bool($includeFormatting)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($includeFormatting)), __LINE__);
        }
        $this->IncludeFormatting = $includeFormatting;
        return $this;
    }
    /**
     * Get IncludeSuggestions value
     * @return bool|null
     */
    public function getIncludeSuggestions()
    {
        return $this->IncludeSuggestions;
    }
    /**
     * Set IncludeSuggestions value
     * @param bool $includeSuggestions
     * @return \StructType\ValidateAddressOptionsType
     */
    public function setIncludeSuggestions($includeSuggestions = null)
    {
        // validation for constraint: boolean
        if (!is_null($includeSuggestions) && !is_bool($includeSuggestions)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($includeSuggestions)), __LINE__);
        }
        $this->IncludeSuggestions = $includeSuggestions;
        return $this;
    }
    /**
     * Get IncludeSubmittedAddress value
     * @return bool|null
     */
    public function getIncludeSubmittedAddress()
    {
        return $this->IncludeSubmittedAddress;
    }
    /**
     * Set IncludeSubmittedAddress value
     * @param bool $includeSubmittedAddress
     * @return \StructType\ValidateAddressOptionsType
     */
    public function setIncludeSubmittedAddress($includeSubmittedAddress = null)
    {
        // validation for constraint: boolean
        if (!is_null($includeSubmittedAddress) && !is_bool($includeSubmittedAddress)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($includeSubmittedAddress)), __LINE__);
        }
        $this->IncludeSubmittedAddress = $includeSubmittedAddress;
        return $this;
    }
    /**
     * Get IncludeDefaultGeoLocation value
     * @return bool|null
     */
    public function getIncludeDefaultGeoLocation()
    {
        return $this->IncludeDefaultGeoLocation;
    }
    /**
     * Set IncludeDefaultGeoLocation value
     * @param bool $includeDefaultGeoLocation
     * @return \StructType\ValidateAddressOptionsType
     */
    public function setIncludeDefaultGeoLocation($includeDefaultGeoLocation = null)
    {
        // validation for constraint: boolean
        if (!is_null($includeDefaultGeoLocation) && !is_bool($includeDefaultGeoLocation)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($includeDefaultGeoLocation)), __LINE__);
        }
        $this->IncludeDefaultGeoLocation = $includeDefaultGeoLocation;
        return $this;
    }
    /**
     * Get IncludeSuffixList value
     * @return bool|null
     */
    public function getIncludeSuffixList()
    {
        return $this->IncludeSuffixList;
    }
    /**
     * Set IncludeSuffixList value
     * @param bool $includeSuffixList
     * @return \StructType\ValidateAddressOptionsType
     */
    public function setIncludeSuffixList($includeSuffixList = null)
    {
        // validation for constraint: boolean
        if (!is_null($includeSuffixList) && !is_bool($includeSuffixList)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($includeSuffixList)), __LINE__);
        }
        $this->IncludeSuffixList = $includeSuffixList;
        return $this;
    }
    /**
     * Get IncludeNumberOfSuffixes value
     * @return bool|null
     */
    public function getIncludeNumberOfSuffixes()
    {
        return $this->IncludeNumberOfSuffixes;
    }
    /**
     * Set IncludeNumberOfSuffixes value
     * @param bool $includeNumberOfSuffixes
     * @return \StructType\ValidateAddressOptionsType
     */
    public function setIncludeNumberOfSuffixes($includeNumberOfSuffixes = null)
    {
        // validation for constraint: boolean
        if (!is_null($includeNumberOfSuffixes) && !is_bool($includeNumberOfSuffixes)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($includeNumberOfSuffixes)), __LINE__);
        }
        $this->IncludeNumberOfSuffixes = $includeNumberOfSuffixes;
        return $this;
    }
    /**
     * Get IncludeListOfBoxes value
     * @return bool|null
     */
    public function getIncludeListOfBoxes()
    {
        return $this->IncludeListOfBoxes;
    }
    /**
     * Set IncludeListOfBoxes value
     * @param bool $includeListOfBoxes
     * @return \StructType\ValidateAddressOptionsType
     */
    public function setIncludeListOfBoxes($includeListOfBoxes = null)
    {
        // validation for constraint: boolean
        if (!is_null($includeListOfBoxes) && !is_bool($includeListOfBoxes)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($includeListOfBoxes)), __LINE__);
        }
        $this->IncludeListOfBoxes = $includeListOfBoxes;
        return $this;
    }
    /**
     * Get IncludeNumberOfBoxes value
     * @return bool|null
     */
    public function getIncludeNumberOfBoxes()
    {
        return $this->IncludeNumberOfBoxes;
    }
    /**
     * Set IncludeNumberOfBoxes value
     * @param bool $includeNumberOfBoxes
     * @return \StructType\ValidateAddressOptionsType
     */
    public function setIncludeNumberOfBoxes($includeNumberOfBoxes = null)
    {
        // validation for constraint: boolean
        if (!is_null($includeNumberOfBoxes) && !is_bool($includeNumberOfBoxes)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($includeNumberOfBoxes)), __LINE__);
        }
        $this->IncludeNumberOfBoxes = $includeNumberOfBoxes;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ValidateAddressOptionsType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
