<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ValidatedAddressResultList StructType
 * @subpackage Structs
 */
class ValidatedAddressResultList extends AbstractStructBase
{
    /**
     * The ValidatedAddressResult
     * Meta informations extracted from the WSDL
     * - maxOccurs: 200
     * @var \StructType\ValidatedAddressResultType[]
     */
    public $ValidatedAddressResult;
    /**
     * Constructor method for ValidatedAddressResultList
     * @uses ValidatedAddressResultList::setValidatedAddressResult()
     * @param \StructType\ValidatedAddressResultType[] $validatedAddressResult
     */
    public function __construct(array $validatedAddressResult = array())
    {
        $this
            ->setValidatedAddressResult($validatedAddressResult);
    }
    /**
     * Get ValidatedAddressResult value
     * @return \StructType\ValidatedAddressResultType[]|null
     */
    public function getValidatedAddressResult()
    {
        return $this->ValidatedAddressResult;
    }
    /**
     * Set ValidatedAddressResult value
     * @throws \InvalidArgumentException
     * @param \StructType\ValidatedAddressResultType[] $validatedAddressResult
     * @return \StructType\ValidatedAddressResultList
     */
    public function setValidatedAddressResult(array $validatedAddressResult = array())
    {
        foreach ($validatedAddressResult as $validatedAddressResultListValidatedAddressResultItem) {
            // validation for constraint: itemType
            if (!$validatedAddressResultListValidatedAddressResultItem instanceof \StructType\ValidatedAddressResultType) {
                throw new \InvalidArgumentException(sprintf('The ValidatedAddressResult property can only contain items of \StructType\ValidatedAddressResultType, "%s" given', is_object($validatedAddressResultListValidatedAddressResultItem) ? get_class($validatedAddressResultListValidatedAddressResultItem) : gettype($validatedAddressResultListValidatedAddressResultItem)), __LINE__);
            }
        }
        $this->ValidatedAddressResult = $validatedAddressResult;
        return $this;
    }
    /**
     * Add item to ValidatedAddressResult value
     * @throws \InvalidArgumentException
     * @param \StructType\ValidatedAddressResultType $item
     * @return \StructType\ValidatedAddressResultList
     */
    public function addToValidatedAddressResult(\StructType\ValidatedAddressResultType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ValidatedAddressResultType) {
            throw new \InvalidArgumentException(sprintf('The ValidatedAddressResult property can only contain items of \StructType\ValidatedAddressResultType, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->ValidatedAddressResult[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ValidatedAddressResultList
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
